// [=====================================================================]

//    Name:  KeyInjectModuleDlg.h     Last Modified:  
//    Author:							First Working:  
//  
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#if !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
#define AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_

#include "USB.H"
#include <afxmt.h>
#include "idt_usb_hid.h"
#include "KeyDlg.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DES_MODE  = 0;
#define TDES_MODE = 1;


/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

class CKeyInjectModuleDlg : public CDialog
{
// Construction
public:
	CString m_Method;

	int Getkey(int ilen , byte *pRtrn);
	BOOL m_isFrist;
	int m_iCurrentOperation;
	CString FormatHexToStr(byte * pBKCV);
	int m_NoOfDevices;

	void FreeMem(unsigned char * pCh);
	void SetToHex(const byte *inBuff, byte *outBuff,int iLen);
	
	void Decryption();
	byte asctohex(byte m, byte n);	
	byte asctodec(byte m, byte n);
	CString	StrInput_Data;
	CString	StrInput;

	BYTE	m_Track1Buffer[1000];
	BYTE	m_Track2Buffer[1000];
	BYTE	m_Track3Buffer[1000];
	BYTE	m_SessionIDBuffer[16];
	
	DWORD	DataLen;
	DWORD	DataLen1;
	DWORD	DataLen2;
	DWORD	DataLen3;

	DWORD	m_CardType;
	BYTE	m_WholeCardDataBuf[400];
	UINT	WholeCardDataLen;
	CString	m_NotificationData;
	unsigned char m_cryptoKey[16];

	CString	m_str_initial_key;

	//array for KSN
	unsigned char m_cksn[20];  
    unsigned char m_nksn[10];     

	//array for PIN
	unsigned char m_cpin[16];
	unsigned char m_npin[8];

	//array for initial key of DUKPT
	unsigned char m_cinitial_key[32];
	unsigned char m_nderivation_key[16];
	unsigned char m_ninitial_key[16];

	//PIN block
	unsigned char m_npin_block[8];

	BOOL bTrk1;
	BOOL bTrk2;
	BOOL bTrk3;

	//Decryption Mode
	int bDecryptMode;
	int KBMode;

	CMenu		m_menu;
	UINT		m_Timer;
    CFont		m_font;
	KeyDlg		m_KeyDlg;

//	CKeyRetriver m_KetRtrvr;
	CKeyInjectModuleDlg(CWnd* pParent = NULL);	// standard constructor
	void Received_HID_Data(); 



// Dialog Data
	//{{AFX_DATA(CKeyInjectModuleDlg)
	enum { IDD = IDD_KEYINJECTMODULE_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeyInjectModuleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CString		StrCommand;
	// Generated message map functions
	//{{AFX_MSG(CKeyInjectModuleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExit();
	afx_msg void OnSend();
	afx_msg void OnDecrypt();
	afx_msg void OnInputKey();
	afx_msg void OnMENUSetDefault();
	afx_msg void OnMENUReadConfiguration();
	afx_msg void OnMENUReadFirmware();
	afx_msg void OnMENUBeeperOff();
	afx_msg void OnMENUBeeperLow();
	afx_msg void OnMENUBeeperHigh();
	afx_msg void OnMENUReadBothDirections();
	afx_msg void OnMENUReadForwardDirection();
	afx_msg void OnMENUReadBackwardDirection();
	afx_msg void OnMENUAbout();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMenuTdes();
	afx_msg void OnMenuAes();
	afx_msg void OnMENUSetPrePANClrDataID();
	afx_msg void OnMENUSetPostPANClrDataID();
	afx_msg void OnMENUSetMaskCharID();
	afx_msg void OnMSREnableID();
	afx_msg void OnMSRDisableID();
	afx_msg void OnSecurityLevID();
	afx_msg void OnHIDIDTMode();
	afx_msg void OnUSBKBMode();
	afx_msg void OnMENUSetPollingInterval();
	afx_msg void OnMENUSetUK();
	afx_msg void OnMENUSetUniversal();
	afx_msg void OnMENUSetUnBufferMode();
	afx_msg void OnSetpollinginterval1();
	afx_msg void OnGetDeviceSN();
	afx_msg void OnEnterKey();
	afx_msg void OnActauth();
	afx_msg void OnActrply();
	afx_msg void OnDeactrply();
	afx_msg void OnStatus();
	afx_msg void OnMENUForceEncryptAllTracks();
	afx_msg void OnMENUNewEncryptionFormat();
	afx_msg void OnMENUOldEncryptionFormat();
	afx_msg void OnSynchronize();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
//	CString		StrBuff;
//	CString		StrScriptCommand;

	BOOL		MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd);
	BYTE		Char2Hex(char ch);	
	int  FileOpen();
	int  ExtractData();
	void ScriptData();


	bool SendCommandRequest(byte* datapool, int outLength);
	void CheckReaderConnection(void);


};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
